/* MODULE NAME:  k_rx_los.h
 * PURPOSE:
 *  header file of RX_LOS for linux kernel
 *
 * NOTES:
 *
 * HISTORY
 *    8/15/2017 - Mark Hsieh, Created
 *
 * Copyright(C)      Edgecore Corporation, 2017
 */
#ifndef K_RX_LOS_H
#define K_RX_LOS_H

/* INCLUDE FILE DECLARATIONS
 */

/* NAMING CONSTANT DECLARATIONS
 */
enum {
    RX_LOS_TYPE_SYSCALL_CMD_WAIT_EVENT=0,
    RX_LOS_TYPE_SYSCALL_CMD_DEBUG,
    RX_LOS_TYPE_SYSCALL_CMD_ENABLE_INT,
    RX_LOS_TYPE_SYSCALL_CMD_WAKE_UP_WQ,
};

/* MACRO FUNCTION DECLARATIONS
 */

/* DATA TYPE DECLARATIONS
 */

/* EXPORTED SUBPROGRAM SPECIFICATIONS
 */
/*--------------------------------------------------------------------------
 * 	FUNCTION NAME : RX_LOS_Init
 *--------------------------------------------------------------------------
 * 	PURPOSE:
 *   Initialize RX_LOS.
 *
 * 	INPUT:
 *   None.
 *
 * 	OUTPUT:
 *   None.
 *
 * 	RETURN:
 *   None.
 *
 * 	NOTES:
 *   None.
 *--------------------------------------------------------------------------
 */
void RX_LOS_Init(void);

/*--------------------------------------------------------------------------
 * FUNCTION NAME - RX_LOS_Create_InterCSC_Relation
 *--------------------------------------------------------------------------
 * PURPOSE:
 *   This function initializes all function pointer registration operations.
 *
 * INPUT:
 *   None.
 *
 * OUTPUT:
 *   None.
 *
 * RETURN
 *   None.
 *
 * NOTES:
 *   None.
 *--------------------------------------------------------------------------*/
void RX_LOS_Create_InterCSC_Relation(void);

#endif /* End of K_RX_LOS_H */
