/* MODULE NAME:  leaf_foundry_sn_agent.h
 *
 * PURPOSE: Leaf constants for Brocade's FOUNDRY-SN-AGENT-MIB:
 *
 * MODULE-IDENTITY node:
 * foundry(1991).snAgent(4) - nothing inside
 *
 * Variables:
 * foundry(1991).products(1).switch(1).snChassis(1).*
 * foundry(1991).products(1).switch(1).snAgentSys(2).*
 *
 * NOTES:
 *
 * HISTORY (mm/dd/yyyy)
 *    05/30/2011 - Qiyao Zhong, Created
 *
 * Copyright(C)      Accton Corporation, 2011
 */

/* Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.4 2004/07/28 08:04:58 dts12 Exp $
 */
#ifndef LEAF_FOUNDRY_SN_AGENT_H
#define LEAF_FOUNDRY_SN_AGENT_H

/* ------------------------------------------------------------------------
 * SCALAR NODES - 1.1.1.1 snChasGen.*
 * ------------------------------------------------------------------------
 */
#define LEAF_snChasSerNum   2
#define MINSIZE_snChasSerNum  0L
#define MAXSIZE_snChasSerNum  128L

#define LEAF_snChasMainBrdDescription   5
#define MINSIZE_snChasMainBrdDescription  0L
#define MAXSIZE_snChasMainBrdDescription  128L

#define LEAF_snChasMainPortTotal   6
#define MIN_snChasMainPortTotal  1L
#define MAX_snChasMainPortTotal  24L

#define LEAF_snChasActualTemperature   18
#define MIN_snChasActualTemperature  (-110L)
#define MAX_snChasActualTemperature  250L

#define LEAF_snChasNumSlots   24

/* ------------------------------------------------------------------------
 * TABLE NAME - 1.1.1.2.2 snChasPwrSupply2Table
 * ------------------------------------------------------------------------
 */
#define LEAF_snChasPwrSupply2Unit   1

#define LEAF_snChasPwrSupply2Index   2

#define LEAF_snChasPwrSupply2Description   3
#define MINSIZE_snChasPwrSupply2Description  0L
#define MAXSIZE_snChasPwrSupply2Description  128L
#define LEAF_snChasPwrSupply2OperStatus   4
#define VAL_snChasPwrSupply2OperStatus_other 1L
#define VAL_snChasPwrSupply2OperStatus_normal 2L
#define VAL_snChasPwrSupply2OperStatus_failure 3L

/* ------------------------------------------------------------------------
 * TABLE NAME - 1.1.1.4.1 snChasUnitTable
 * ------------------------------------------------------------------------
 */
#define LEAF_snChasUnitIndex   1

#define LEAF_snChasUnitSerNum   2
#define MINSIZE_snChasUnitSerNum  0L
#define MAXSIZE_snChasUnitSerNum  128L

#define LEAF_snChasUnitNumSlots   3

#define LEAF_snChasUnitActualTemperature   4
#define MIN_snChasUnitActualTemperature  -110L
#define MAX_snChasUnitActualTemperature  250L

#define LEAF_snChasUnitWarningTemperature   5
#define MIN_snChasUnitWarningTemperature  0L
#define MAX_snChasUnitWarningTemperature  250L

#define LEAF_snChasUnitShutdownTemperature   6
#define MIN_snChasUnitShutdownTemperature  0L
#define MAX_snChasUnitShutdownTemperature  250L

#define LEAF_snChasUnitPartNum   7
#define SIZE_snChasUnitPartNum 1L

/* ------------------------------------------------------------------------
 * SCALAR NODES - 1.1.2.1 snAgentGbl.*
 * ------------------------------------------------------------------------
 */
#define LEAF_snAgReload   1
#define VAL_snAgReload_other 1L
#define VAL_snAgReload_running 2L
#define VAL_snAgReload_reset 3L
#define VAL_snAgReload_busy 4L

#define LEAF_snAgEraseNVRAM   2
#define VAL_snAgEraseNVRAM_normal 1L
#define VAL_snAgEraseNVRAM_error 2L
#define VAL_snAgEraseNVRAM_erase 3L
#define VAL_snAgEraseNVRAM_erasing 4L
#define VAL_snAgEraseNVRAM_busy 5L

#define LEAF_snAgWriteNVRAM   3
#define VAL_snAgWriteNVRAM_normal 1L
#define VAL_snAgWriteNVRAM_error 2L
#define VAL_snAgWriteNVRAM_write 3L
#define VAL_snAgWriteNVRAM_writing 4L
#define VAL_snAgWriteNVRAM_busy 5L

#define LEAF_snAgConfigFromNVRAM   4
#define VAL_snAgConfigFromNVRAM_normal 1L
#define VAL_snAgConfigFromNVRAM_error 2L
#define VAL_snAgConfigFromNVRAM_config 3L
#define VAL_snAgConfigFromNVRAM_configing 4L
#define VAL_snAgConfigFromNVRAM_busy 5L

#define LEAF_snAgImgFname   6
#define MINSIZE_snAgImgFname  0L
#define MAXSIZE_snAgImgFname  32L

#define LEAF_snAgImgLoad   7
#define VAL_snAgImgLoad_normal 1L
#define VAL_snAgImgLoad_flashPrepareReadFailure 2L
#define VAL_snAgImgLoad_flashReadError 3L
#define VAL_snAgImgLoad_flashPrepareWriteFailure 4L
#define VAL_snAgImgLoad_flashWriteError 5L
#define VAL_snAgImgLoad_tftpTimeoutError 6L
#define VAL_snAgImgLoad_tftpOutOfBufferSpace 7L
#define VAL_snAgImgLoad_tftpBusy 8L
#define VAL_snAgImgLoad_tftpRemoteOtherErrors 9L
#define VAL_snAgImgLoad_tftpRemoteNoFile 10L
#define VAL_snAgImgLoad_tftpRemoteBadAccess 11L
#define VAL_snAgImgLoad_tftpRemoteDiskFull 12L
#define VAL_snAgImgLoad_tftpRemoteBadOperation 13L
#define VAL_snAgImgLoad_tftpRemoteBadId 14L
#define VAL_snAgImgLoad_tftpRemoteFileExists 15L
#define VAL_snAgImgLoad_tftpRemoteNoUser 16L
#define VAL_snAgImgLoad_operationError 17L
#define VAL_snAgImgLoad_loading 18L
#define VAL_snAgImgLoad_uploadMPPrimary 19L
#define VAL_snAgImgLoad_downloadMPPrimary 20L
#define VAL_snAgImgLoad_uploadMPSecondary 21L
#define VAL_snAgImgLoad_downloadMPSecondary 22L
#define VAL_snAgImgLoad_tftpWrongFileType 23L
#define VAL_snAgImgLoad_downloadSPPrimary 24L
#define VAL_snAgImgLoad_downloadSPSecondary 25L
#define VAL_snAgImgLoad_uploadMPBootROM 26L
#define VAL_snAgImgLoad_downloadMPBootROM 27L
#define VAL_snAgImgLoad_uploadMPBootTFTP 28L
#define VAL_snAgImgLoad_downloadMPBootTFTP 29L
#define VAL_snAgImgLoad_uploadMPMonitor 30L
#define VAL_snAgImgLoad_downloadMPMonitor 31L
#define VAL_snAgImgLoad_downloadSPBootROM 32L

#define LEAF_snAgCfgFname   8
#define MINSIZE_snAgCfgFname  0L
#define MAXSIZE_snAgCfgFname  32L

#define LEAF_snAgCfgLoad   9
#define VAL_snAgCfgLoad_normal 1L
#define VAL_snAgCfgLoad_flashPrepareReadFailure 2L
#define VAL_snAgCfgLoad_flashReadError 3L
#define VAL_snAgCfgLoad_flashPrepareWriteFailure 4L
#define VAL_snAgCfgLoad_flashWriteError 5L
#define VAL_snAgCfgLoad_tftpTimeoutError 6L
#define VAL_snAgCfgLoad_tftpOutOfBufferSpace 7L
#define VAL_snAgCfgLoad_tftpBusy 8L
#define VAL_snAgCfgLoad_tftpRemoteOtherErrors 9L
#define VAL_snAgCfgLoad_tftpRemoteNoFile 10L
#define VAL_snAgCfgLoad_tftpRemoteBadAccess 11L
#define VAL_snAgCfgLoad_tftpRemoteDiskFull 12L
#define VAL_snAgCfgLoad_tftpRemoteBadOperation 13L
#define VAL_snAgCfgLoad_tftpRemoteBadId 14L
#define VAL_snAgCfgLoad_tftpRemoteFileExists 15L
#define VAL_snAgCfgLoad_tftpRemoteNoUser 16L
#define VAL_snAgCfgLoad_operationError 17L
#define VAL_snAgCfgLoad_loading 18L
#define VAL_snAgCfgLoad_uploadFromFlashToServer 20L
#define VAL_snAgCfgLoad_downloadToFlashFromServer 21L
#define VAL_snAgCfgLoad_uploadFromDramToServer 22L
#define VAL_snAgCfgLoad_downloadToDramFromServer 23L
#define VAL_snAgCfgLoad_uploadFromFlashToNMS 24L
#define VAL_snAgCfgLoad_downloadToFlashFromNMS 25L
#define VAL_snAgCfgLoad_uploadFromDramToNMS 26L
#define VAL_snAgCfgLoad_downloadToDramFromNMS 27L
#define VAL_snAgCfgLoad_operationDoneWithNMS 28L
#define VAL_snAgCfgLoad_tftpWrongFileType 29L
#define VAL_snAgCfgLoad_downloadToDramFromServerOverwrite 30L

#define LEAF_snAgDefGwayIp   10

#define LEAF_snAgImgVer   11
#define MINSIZE_snAgImgVer  0L
#define MAXSIZE_snAgImgVer  32L

#define LEAF_snAgGblIfIpAddr   13

#define LEAF_snAgGblIfIpMask   14

#define LEAF_snAgTrpRcvrCurEntry   16
#define MIN_snAgTrpRcvrCurEntry  0L
#define MAX_snAgTrpRcvrCurEntry  255L

#define LEAF_snAgGblTelnetTimeout   37
#define MIN_snAgGblTelnetTimeout  0L
#define MAX_snAgGblTelnetTimeout  240L

#define LEAF_snAgGblEnableWebMgmt   38
#define VAL_snAgGblEnableWebMgmt_disabled 0L
#define VAL_snAgGblEnableWebMgmt_enabled 1L

#define LEAF_snAgSoftwareFeature   41
#define SIZE_snAgSoftwareFeature 1L

#define LEAF_snAgGblTrapMessage   44
#define SIZE_snAgGblTrapMessage 1L

#define LEAF_snAgGblEnableTelnetServer   45
#define VAL_snAgGblEnableTelnetServer_disabled 0L
#define VAL_snAgGblEnableTelnetServer_enabled 1L

#define LEAF_snAgBuildDate   47
#define MINSIZE_snAgBuildDate  0L
#define MAXSIZE_snAgBuildDate  32L

#define LEAF_snAgBuildtime   48
#define MINSIZE_snAgBuildtime  0L
#define MAXSIZE_snAgBuildtime  32L

#define LEAF_snAgGblCpuUtil5SecAvg   51

#define LEAF_snAgGblCpuUtil1MinAvg   52

#define LEAF_snAgGblTelnetLoginTimeout   60
#define MIN_snAgGblTelnetLoginTimeout  1L
#define MAX_snAgGblTelnetLoginTimeout  10L

#define LEAF_snAgWebMgmtServerTcpPort   64
#define MIN_snAgWebMgmtServerTcpPort  1L
#define MAX_snAgWebMgmtServerTcpPort  65535L

#define LEAF_snAgTftpServerAddrType   65
#define VAL_snAgTftpServerAddrType_unknown 0L
#define VAL_snAgTftpServerAddrType_ipv4 1L
#define VAL_snAgTftpServerAddrType_ipv6 2L
#define VAL_snAgTftpServerAddrType_ipv4z 3L
#define VAL_snAgTftpServerAddrType_ipv6z 4L
#define VAL_snAgTftpServerAddrType_dns 16L

#define LEAF_snAgTftpServerAddr   66
#define MINSIZE_snAgTftpServerAddr  0L
#define MAXSIZE_snAgTftpServerAddr  255L

/* ------------------------------------------------------------------------
 * SCALAR NODES - 1.1.2.12 snAgentHw.snAgSystemDRAM(1).*
 * ------------------------------------------------------------------------
 */
#define LEAF_snAgSystemDRAMUtil   1

#define LEAF_snAgSystemDRAMTotal   2

#define LEAF_snAgSystemDRAMFree   3

/* ------------------------------------------------------------------------
 * TABLE NAME - 1.1.2.13 snAgentTemp.snAgentTemp2Table(3)
 * ------------------------------------------------------------------------
 */
#define LEAF_snAgentTemp2UnitNum   1
#define LEAF_snAgentTemp2SlotNum   2
#define LEAF_snAgentTemp2SensorId   3
#define LEAF_snAgentTemp2SensorDescr   4
#define MINSIZE_snAgentTemp2SensorDescr  0L
#define MAXSIZE_snAgentTemp2SensorDescr  128L
#define LEAF_snAgentTemp2Value   5
#define MIN_snAgentTemp2Value  (-110L)
#define MAX_snAgentTemp2Value  250L

#endif  /* LEAF_FOUNDRY_SN_AGENT_H */
