/* MODULE NAME:  leaf_foundry_sn_switch_group.h
 *
 * PURPOSE: Leaf constants for Brocade's FOUNDRY-SN-SWITCH-GROUP-MIB:
 *
 * foundry(1991).products(1).switch(1).snSwitch(3)
 *
 * NOTES:
 *
 * HISTORY (mm/dd/yyyy)
 *    05/09/2011 - Qiyao Zhong, Created
 *
 * Copyright(C)      Accton Corporation, 2011
 */

/* Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.4 2004/07/28 08:04:58 dts12 Exp $
 */
#ifndef LEAF_FOUNDRY_SN_SWITCH_GROUP_H
#define LEAF_FOUNDRY_SN_SWITCH_GROUP_H

/* ------------------------------------------------------------------------
 * SCALAR NODES - 1.1.3.1 snSwInfo.*
 * ------------------------------------------------------------------------
 */
#define LEAF_snSwGroupIpMcastMode   3
#define VAL_snSwGroupIpMcastMode_disabled 0L
#define VAL_snSwGroupIpMcastMode_enabled 1L

#define LEAF_snFdbTableCurEntry   9

#define LEAF_snFdbTableStationFlush   10
#define VAL_snFdbTableStationFlush_normal 1L
#define VAL_snFdbTableStationFlush_error 2L
#define VAL_snFdbTableStationFlush_flush 3L
#define VAL_snFdbTableStationFlush_flushing 4L

#define LEAF_snSwGlobalStpMode   14
#define VAL_snSwGlobalStpMode_disabled 0L
#define VAL_snSwGlobalStpMode_enabled 1L

#define LEAF_snSwIpMcastQuerierMode   15
#define VAL_snSwIpMcastQuerierMode_querier 1L
#define VAL_snSwIpMcastQuerierMode_nonQuerier 2L

#define LEAF_snSwClearCounters   33
#define VAL_snSwClearCounters_valid 0L
#define VAL_snSwClearCounters_clear 1L

#define LEAF_snSwQosMechanism   40
#define VAL_snSwQosMechanism_strict 0L
#define VAL_snSwQosMechanism_weighted 1L

#define LEAF_snSwSingleStpMode   41
#define VAL_snSwSingleStpMode_disable 0L
#define VAL_snSwSingleStpMode_enableStp 1L
#define VAL_snSwSingleStpMode_enableRstp 2L

/* ------------------------------------------------------------------------
 * TABLE NAME - 1.1.3.3.5 snSwIfInfoTable
 * ------------------------------------------------------------------------
 */
#define LEAF_snSwIfInfoPortNum   1
#define MIN_snSwIfInfoPortNum  1L
#define MAX_snSwIfInfoPortNum  2147483647L
#define LEAF_snSwIfInfoMonitorMode   2
#define VAL_snSwIfInfoMonitorMode_disabled 0L
#define VAL_snSwIfInfoMonitorMode_input 1L
#define VAL_snSwIfInfoMonitorMode_output 2L
#define VAL_snSwIfInfoMonitorMode_both 3L
#define LEAF_snSwIfInfoMirrorPorts   3
#define SIZE_snSwIfInfoMirrorPorts 1L
#define LEAF_snSwIfInfoTagMode   4
#define VAL_snSwIfInfoTagMode_tagged 1L
#define VAL_snSwIfInfoTagMode_untagged 2L
#define VAL_snSwIfInfoTagMode_dual 3L
#define LEAF_snSwIfInfoTagType   5
#define LEAF_snSwIfInfoChnMode   6
#define VAL_snSwIfInfoChnMode_none 0L
#define VAL_snSwIfInfoChnMode_halfDuplex 1L
#define VAL_snSwIfInfoChnMode_fullDuplex 2L
#define LEAF_snSwIfInfoSpeed   7
#define VAL_snSwIfInfoSpeed_none 0L
#define VAL_snSwIfInfoSpeed_sAutoSense 1L
#define VAL_snSwIfInfoSpeed_s10M 2L
#define VAL_snSwIfInfoSpeed_s100M 3L
#define VAL_snSwIfInfoSpeed_s1G 4L
#define VAL_snSwIfInfoSpeed_s1GM 5L
#define VAL_snSwIfInfoSpeed_s155M 6L
#define VAL_snSwIfInfoSpeed_s10G 7L
#define VAL_snSwIfInfoSpeed_s622M 8L
#define VAL_snSwIfInfoSpeed_s2488M 9L
#define VAL_snSwIfInfoSpeed_s9953M 10L
#define VAL_snSwIfInfoSpeed_s16G 11L
#define LEAF_snSwIfInfoMediaType   8
#define VAL_snSwIfInfoMediaType_other 1L
#define VAL_snSwIfInfoMediaType_m100BaseTX 2L
#define VAL_snSwIfInfoMediaType_m100BaseFX 3L
#define VAL_snSwIfInfoMediaType_m1000BaseFX 4L
#define VAL_snSwIfInfoMediaType_mT3 5L
#define VAL_snSwIfInfoMediaType_m155ATM 6L
#define VAL_snSwIfInfoMediaType_m1000BaseTX 7L
#define VAL_snSwIfInfoMediaType_m622ATM 8L
#define VAL_snSwIfInfoMediaType_m155POS 9L
#define VAL_snSwIfInfoMediaType_m622POS 10L
#define VAL_snSwIfInfoMediaType_m2488POS 11L
#define VAL_snSwIfInfoMediaType_m10000BaseFX 12L
#define VAL_snSwIfInfoMediaType_m9953POS 13L
#define VAL_snSwIfInfoMediaType_m16GStacking 14L
#define LEAF_snSwIfInfoConnectorType   9
#define VAL_snSwIfInfoConnectorType_other 1L
#define VAL_snSwIfInfoConnectorType_copper 2L
#define VAL_snSwIfInfoConnectorType_fiber 3L
#define LEAF_snSwIfInfoAdminStatus   10
#define VAL_snSwIfInfoAdminStatus_up 1L
#define VAL_snSwIfInfoAdminStatus_down 2L
#define VAL_snSwIfInfoAdminStatus_testing 3L
#define LEAF_snSwIfInfoLinkStatus   11
#define VAL_snSwIfInfoLinkStatus_up 1L
#define VAL_snSwIfInfoLinkStatus_down 2L
#define VAL_snSwIfInfoLinkStatus_testing 3L
#define LEAF_snSwIfInfoPortQos   12
#define VAL_snSwIfInfoPortQos_level0 0L
#define VAL_snSwIfInfoPortQos_level1 1L
#define VAL_snSwIfInfoPortQos_level2 2L
#define VAL_snSwIfInfoPortQos_level3 3L
#define VAL_snSwIfInfoPortQos_level4 4L
#define VAL_snSwIfInfoPortQos_level5 5L
#define VAL_snSwIfInfoPortQos_level6 6L
#define VAL_snSwIfInfoPortQos_level7 7L
#define LEAF_snSwIfInfoPhysAddress   13
#define SIZE_snSwIfInfoPhysAddress 1L
#define LEAF_snSwIfLockAddressCount   14
#define MIN_snSwIfLockAddressCount  0L
#define MAX_snSwIfLockAddressCount  2048L
#define LEAF_snSwIfStpPortEnable   15
#define VAL_snSwIfStpPortEnable_disabled 0L
#define VAL_snSwIfStpPortEnable_enabled 1L
#define LEAF_snSwIfDhcpGateListId   16
#define MIN_snSwIfDhcpGateListId  0L
#define MAX_snSwIfDhcpGateListId  32L
#define LEAF_snSwIfName   17
#define MINSIZE_snSwIfName  0L
#define MAXSIZE_snSwIfName  255L
#define LEAF_snSwIfDescr   18
#define SIZE_snSwIfDescr 1L
#define LEAF_snSwIfInfoAutoNegotiate   19
#define VAL_snSwIfInfoAutoNegotiate_disabled 0L
#define VAL_snSwIfInfoAutoNegotiate_enabled 1L
#define VAL_snSwIfInfoAutoNegotiate_negFullAuto 2L
#define VAL_snSwIfInfoAutoNegotiate_global 3L
#define VAL_snSwIfInfoAutoNegotiate_other 4L
#define LEAF_snSwIfInfoFlowControl   20
#define VAL_snSwIfInfoFlowControl_disabled 0L
#define VAL_snSwIfInfoFlowControl_enabled 1L
#define LEAF_snSwIfInfoGigType   21
#define VAL_snSwIfInfoGigType_m1000BaseSX 0L
#define VAL_snSwIfInfoGigType_m1000BaseLX 1L
#define VAL_snSwIfInfoGigType_m1000BaseLH 2L
#define VAL_snSwIfInfoGigType_m1000BaseLHA 3L
#define VAL_snSwIfInfoGigType_m1000BaseLHB 4L
#define VAL_snSwIfInfoGigType_m1000BaseTX 5L
#define VAL_snSwIfInfoGigType_m10000BaseSR 6L
#define VAL_snSwIfInfoGigType_m10000BaseLR 7L
#define VAL_snSwIfInfoGigType_m10000BaseER 8L
#define VAL_snSwIfInfoGigType_sfpCWDM1470nm80Km 9L
#define VAL_snSwIfInfoGigType_sfpCWDM1490nm80Km 10L
#define VAL_snSwIfInfoGigType_sfpCWDM1510nm80Km 11L
#define VAL_snSwIfInfoGigType_sfpCWDM1530nm80Km 12L
#define VAL_snSwIfInfoGigType_sfpCWDM1550nm80Km 13L
#define VAL_snSwIfInfoGigType_sfpCWDM1570nm80Km 14L
#define VAL_snSwIfInfoGigType_sfpCWDM1590nm80Km 15L
#define VAL_snSwIfInfoGigType_sfpCWDM1610nm80Km 16L
#define VAL_snSwIfInfoGigType_sfpCWDM1470nm100Km 17L
#define VAL_snSwIfInfoGigType_sfpCWDM1490nm100Km 18L
#define VAL_snSwIfInfoGigType_sfpCWDM1510nm100Km 19L
#define VAL_snSwIfInfoGigType_sfpCWDM1530nm100Km 20L
#define VAL_snSwIfInfoGigType_sfpCWDM1550nm100Km 21L
#define VAL_snSwIfInfoGigType_sfpCWDM1570nm100Km 22L
#define VAL_snSwIfInfoGigType_sfpCWDM1590nm100Km 23L
#define VAL_snSwIfInfoGigType_sfpCWDM1610nm100Km 24L
#define VAL_snSwIfInfoGigType_m1000BaseLHX 25L
#define VAL_snSwIfInfoGigType_m1000BaseSX2 26L
#define VAL_snSwIfInfoGigType_mSFP1000BaseBXU 27L
#define VAL_snSwIfInfoGigType_mSFP1000BaseBXD 28L
#define VAL_snSwIfInfoGigType_mSFP100BaseBX 29L
#define VAL_snSwIfInfoGigType_mSFP100BaseBXU 30L
#define VAL_snSwIfInfoGigType_mSFP100BaseBXD 31L
#define VAL_snSwIfInfoGigType_mSFP100BaseFX 32L
#define VAL_snSwIfInfoGigType_mSFP100BaseFXIR 33L
#define VAL_snSwIfInfoGigType_mSFP100BaseFXLR 34L
#define VAL_snSwIfInfoGigType_m1000BaseLMC 35L
#define VAL_snSwIfInfoGigType_mXFP10000BaseSR 36L
#define VAL_snSwIfInfoGigType_mXFP10000BaseLR 37L
#define VAL_snSwIfInfoGigType_mXFP10000BaseER 38L
#define VAL_snSwIfInfoGigType_mXFP10000BaseSW 39L
#define VAL_snSwIfInfoGigType_mXFP10000BaseLW 40L
#define VAL_snSwIfInfoGigType_mXFP10000BaseEW 41L
#define VAL_snSwIfInfoGigType_mXFP10000BaseCX4 42L
#define VAL_snSwIfInfoGigType_mXFP10000BaseZR 43L
#define VAL_snSwIfInfoGigType_mXFP10000BaseZRD 44L
#define VAL_snSwIfInfoGigType_m1000BaseC6553 45L
#define VAL_snSwIfInfoGigType_mXFP10000BaseSRSW 46L
#define VAL_snSwIfInfoGigType_mXFP10000BaseLRLW 47L
#define VAL_snSwIfInfoGigType_mXFP10000BaseEREW 48L
#define VAL_snSwIfInfoGigType_m1000BaseGBXU 127L
#define VAL_snSwIfInfoGigType_m1000BaseGBXD 128L
#define VAL_snSwIfInfoGigType_m1000BaseFBX 129L
#define VAL_snSwIfInfoGigType_m1000BaseFBXU 130L
#define VAL_snSwIfInfoGigType_m1000BaseFBXD 131L
#define VAL_snSwIfInfoGigType_m1000BaseFX 132L
#define VAL_snSwIfInfoGigType_m1000BaseFXIR 133L
#define VAL_snSwIfInfoGigType_m1000BaseFXLR 134L
#define VAL_snSwIfInfoGigType_m1000BaseXGSR 136L
#define VAL_snSwIfInfoGigType_m1000BaseXGLR 137L
#define VAL_snSwIfInfoGigType_m1000BaseXGER 138L
#define VAL_snSwIfInfoGigType_m1000BaseXGSW 139L
#define VAL_snSwIfInfoGigType_m1000BaseXGLW 140L
#define VAL_snSwIfInfoGigType_m1000BaseXGEW 141L
#define VAL_snSwIfInfoGigType_m1000BaseXGCX4 142L
#define VAL_snSwIfInfoGigType_m1000BaseXGZR 143L
#define VAL_snSwIfInfoGigType_m1000BaseXGZRD 144L
#define VAL_snSwIfInfoGigType_notApplicable 255L
#define LEAF_snSwIfFastSpanPortEnable   22
#define VAL_snSwIfFastSpanPortEnable_disabled 0L
#define VAL_snSwIfFastSpanPortEnable_enabled 1L
#define LEAF_snSwIfFastSpanUplinkEnable   23
#define VAL_snSwIfFastSpanUplinkEnable_disabled 0L
#define VAL_snSwIfFastSpanUplinkEnable_enabled 1L
#define LEAF_snSwIfVlanId   24
#define MIN_snSwIfVlanId  0L
#define MAX_snSwIfVlanId  4095L
#define LEAF_snSwIfRouteOnly   25
#define VAL_snSwIfRouteOnly_disabled 0L
#define VAL_snSwIfRouteOnly_enabled 1L
#define LEAF_snSwIfPresent   26
#define VAL_snSwIfPresent_false 0L
#define VAL_snSwIfPresent_true 1L
#define LEAF_snSwIfGBICStatus   27
#define VAL_snSwIfGBICStatus_gbic 1L
#define VAL_snSwIfGBICStatus_miniGBIC 2L
#define VAL_snSwIfGBICStatus_empty 3L
#define VAL_snSwIfGBICStatus_other 4L
#define LEAF_snSwIfLoadInterval   28
#define MIN_snSwIfLoadInterval  30L
#define MAX_snSwIfLoadInterval  300L
#define LEAF_snSwIfStatsInFrames   29
#define LEAF_snSwIfStatsOutFrames   30
#define LEAF_snSwIfStatsAlignErrors   31
#define LEAF_snSwIfStatsFCSErrors   32
#define LEAF_snSwIfStatsMultiColliFrames   33
#define LEAF_snSwIfStatsTxColliFrames   34
#define LEAF_snSwIfStatsRxColliFrames   35
#define LEAF_snSwIfStatsFrameTooLongs   36
#define LEAF_snSwIfStatsFrameTooShorts   37
#define LEAF_snSwIfStatsInBcastFrames   38
#define LEAF_snSwIfStatsOutBcastFrames   39
#define LEAF_snSwIfStatsInMcastFrames   40
#define LEAF_snSwIfStatsOutMcastFrames   41
#define LEAF_snSwIfStatsInDiscard   42
#define LEAF_snSwIfStatsOutDiscard   43
#define LEAF_snSwIfStatsMacStations   44
#define LEAF_snSwIfStatsLinkChange   45
#define LEAF_snSwIfInOctets   46
#define LEAF_snSwIfOutOctets   47
#define LEAF_snSwIfStatsInBitsPerSec   48
#define LEAF_snSwIfStatsOutBitsPerSec   49
#define LEAF_snSwIfStatsInPktsPerSec   50
#define LEAF_snSwIfStatsOutPktsPerSec   51
#define LEAF_snSwIfStatsInUtilization   52
#define MIN_snSwIfStatsInUtilization  0L
#define MAX_snSwIfStatsInUtilization  10000L
#define LEAF_snSwIfStatsOutUtilization   53
#define MIN_snSwIfStatsOutUtilization  0L
#define MAX_snSwIfStatsOutUtilization  10000L
#define LEAF_snSwIfStatsInKiloBitsPerSec   54
#define LEAF_snSwIfStatsOutKiloBitsPerSec   55
#define LEAF_snSwIfStatsInJumboFrames   56
#define LEAF_snSwIfStatsOutJumboFrames   57
#define LEAF_snSwIfInfoMirrorMode   58
#define VAL_snSwIfInfoMirrorMode_disable 0L
#define VAL_snSwIfInfoMirrorMode_enable 1L
#define LEAF_snSwIfMacLearningDisable   59
#define VAL_snSwIfMacLearningDisable_true 1L
#define VAL_snSwIfMacLearningDisable_false 2L

/* ------------------------------------------------------------------------
 * TABLE NAME - 1.1.3.3.6 snIfOpticalMonitoringInfoTable
 * ------------------------------------------------------------------------
 */
#define LEAF_snIfOpticalMonitoringTemperature   1
#define MINSIZE_snIfOpticalMonitoringTemperature  0L
#define MAXSIZE_snIfOpticalMonitoringTemperature  32L
#define LEAF_snIfOpticalMonitoringTxPower   2
#define MINSIZE_snIfOpticalMonitoringTxPower  0L
#define MAXSIZE_snIfOpticalMonitoringTxPower  32L
#define LEAF_snIfOpticalMonitoringRxPower   3
#define MINSIZE_snIfOpticalMonitoringRxPower  0L
#define MAXSIZE_snIfOpticalMonitoringRxPower  32L
#define LEAF_snIfOpticalMonitoringTxBiasCurrent   4
#define MINSIZE_snIfOpticalMonitoringTxBiasCurrent  0L
#define MAXSIZE_snIfOpticalMonitoringTxBiasCurrent  32L

/* ------------------------------------------------------------------------
 * TABLE NAME - 1.1.3.3.9 snIfMediaInfoTable
 * ------------------------------------------------------------------------
 */
#define LEAF_snIfMediaType   1
#define MINSIZE_snIfMediaType  0L
#define MAXSIZE_snIfMediaType  128L
#define LEAF_snIfMediaVendorName   2
#define MINSIZE_snIfMediaVendorName  0L
#define MAXSIZE_snIfMediaVendorName  128L
#define LEAF_snIfMediaVersion   3
#define MINSIZE_snIfMediaVersion  0L
#define MAXSIZE_snIfMediaVersion  128L
#define LEAF_snIfMediaPartNumber   4
#define MINSIZE_snIfMediaPartNumber  0L
#define MAXSIZE_snIfMediaPartNumber  128L
#define LEAF_snIfMediaSerialNumber   5
#define MINSIZE_snIfMediaSerialNumber  0L
#define MAXSIZE_snIfMediaSerialNumber  128L

/* ------------------------------------------------------------------------
 * TABLE NAME - 1.1.3.10.3 snMacFilterIfAccessTable
 * ------------------------------------------------------------------------
 */
#define LEAF_snMacFilterIfAccessPortIndex   1
#define MIN_snMacFilterIfAccessPortIndex  1L
#define MAX_snMacFilterIfAccessPortIndex  2147483647L
#define LEAF_snMacFilterIfAccessFilters   2
#define SIZE_snMacFilterIfAccessFilters 1L
#define LEAF_snMacFilterIfAccessRowStatus   3
#define VAL_snMacFilterIfAccessRowStatus_invalid 1L
#define VAL_snMacFilterIfAccessRowStatus_valid 2L
#define VAL_snMacFilterIfAccessRowStatus_delete 3L
#define VAL_snMacFilterIfAccessRowStatus_create 4L

/* ------------------------------------------------------------------------
 * SCALAR NODES - 1.1.3.12 snRadius.snRadiusGeneral(1).*
 * ------------------------------------------------------------------------
 */
#define LEAF_snRadiusRetransmit   3
#define MIN_snRadiusRetransmit  0L
#define MAX_snRadiusRetransmit  5L

#define LEAF_snRadiusTimeOut   4
#define MIN_snRadiusTimeOut  1L
#define MAX_snRadiusTimeOut  60L

#define LEAF_snRadiusKey   6

#define LEAF_snRadiusLoginMethod   7
#define MINSIZE_snRadiusLoginMethod  0L
#define MAXSIZE_snRadiusLoginMethod  7L

/* ------------------------------------------------------------------------
 * SCALAR NODES - 1.1.3.13 snTacacs.snTacacsGeneral(1).*
 * ------------------------------------------------------------------------
 */
#define LEAF_snTacacsKey   4

/* ------------------------------------------------------------------------
 * SCALAR NODES - 1.1.3.15 snAAA.snAuthorization(2).*
 * ------------------------------------------------------------------------
 */
#define LEAF_snAuthorizationExec   3
#define MINSIZE_snAuthorizationExec  0L
#define MAXSIZE_snAuthorizationExec  3L

/* ------------------------------------------------------------------------
 * SCALAR NODES - 1.1.3.15 snAAA.snAccounting(3).*
 * ------------------------------------------------------------------------
 */
#define LEAF_snAccountingExec   3
#define MINSIZE_snAccountingExec  0L
#define MAXSIZE_snAccountingExec  3L

/* ------------------------------------------------------------------------
 * TABLE NAME - 1.1.3.24.1.1.3 snPortMacSecurityIntfContentTable
 * ------------------------------------------------------------------------
 */
#define LEAF_snPortMacSecurityIntfContentIfIndex   1
#define MIN_snPortMacSecurityIntfContentIfIndex  1L
#define MAX_snPortMacSecurityIntfContentIfIndex  2147483647L
#define LEAF_snPortMacSecurityIntfContentSecurity   2
#define VAL_snPortMacSecurityIntfContentSecurity_disable 0L
#define VAL_snPortMacSecurityIntfContentSecurity_enable 1L
#define LEAF_snPortMacSecurityIntfContentViolationType   3
#define VAL_snPortMacSecurityIntfContentViolationType_shutdown 0L
#define VAL_snPortMacSecurityIntfContentViolationType_restrict 1L
#define LEAF_snPortMacSecurityIntfContentShutdownTime   4
#define MIN_snPortMacSecurityIntfContentShutdownTime  0L
#define MAX_snPortMacSecurityIntfContentShutdownTime  1440L
#define LEAF_snPortMacSecurityIntfContentShutdownTimeLeft   5
#define LEAF_snPortMacSecurityIntfContentAgeOutTime   6
#define MIN_snPortMacSecurityIntfContentAgeOutTime  0L
#define MAX_snPortMacSecurityIntfContentAgeOutTime  1440L
#define LEAF_snPortMacSecurityIntfContentMaxLockedMacAllowed   7
#define LEAF_snPortMacSecurityIntfContentTotalMACs   8
#define LEAF_snPortMacSecurityIntfContentViolationCounts   9

#endif  /* LEAF_FOUNDRY_SN_SWITCH_GROUP_H */
